Subject: Re: for newbs = little exercise / tutorial / warmup for windows and other non-sophisticated new Git users :-)

From: "Zorba" <[email-masked]>
Date: Wed, 31 Dec 2008 00:31:46 -0000

> So in order for this to make sense, you're going to need to know a little
> tiny bit about branches

** (sigh) At some level I knew I'd have to face up to this... - ok lets do 
it

(which, fortunately, is trivial compared to
> branches in most SCMs). In git, a branch is a mutable pointer to a commit,
> which is the latest commit on the branch (all of the earlier commits on
> the branch are linked off of the latest one; each commit points to the one
> before). By default, you have a branch called "master", and that's the
> branch that your series of commands builds up. Now, at any given time, you
> can have a "current branch" (a.k.a. HEAD), which is the branch that you'd
> put a new commit on if you made one. "master" is your current branch while
> you're building up that history.

> When you want to navigate the history, however, you want to leave all of
> the branches alone and take your working directory into the history. This
> is known as being on "(no branch)" or, as Zippy would say, having a
> "detached HEAD". This way you leave the "master" branch pointing to
> versionD, which is, after all, the latest commit, while you get yourself
> an old version. You can do this with:

> $ git checkout versionA
>
> because you've made a tag for it. In order to get back to developing (as
> opposed to looking at history), you use:
>
> $ git checkout master
>
> (because "master" is your branch, while "versionA" is a tag).
>
> If you're on master, either after checking it out explicitly or before
> you've used checkout at all, doing:
>
> $ git checkout versionA .
>
> with *not* switch you away from the current branch, but will get the
> contents of "." from versionA into your index and working directory, and
> it doesn't remove things that you have currently.

** ok, thanks for explaining - one little dot and my HEAD don't get a 
holiday !

Now, lets say we checkout versionB. I don't just want to be pointing at 
versionB in the repo, I want an exact copy (no more, no less) of all the 
files in version B, to be placed in the working tree. Currently this is not 
happening reliably.

Is that too much to ask ?